// This file is automatically generated from ncp.pac.

#ifndef ncp_pac_h
#define ncp_pac_h

#include <vector>

#include "binpac/binpac.h"

namespace BinPAC {


class ncp_request
{
public:
	ncp_request(int arg_length);
	~ncp_request();
	int parse(const uint8* const t_begin_of_data, const uint8* const t_end_of_data, int t_byteorder);
	
	// Member access functions
	int const length() const { return length_; };
	int const & function() const 	{ return function_; }
	int const & subfunction() const 	{ return subfunction_; }
	array<uint8> const & data() const	{ return data_; }
	
protected:
	int length_;
	int function_;
	int subfunction_;
	array<uint8> data_;
};


class ncp_reply
{
public:
	ncp_reply(int arg_length);
	~ncp_reply();
	int parse(const uint8* const t_begin_of_data, const uint8* const t_end_of_data, int t_byteorder);
	
	// Member access functions
	int const length() const { return length_; };
	uint8 const & completion_code() const	{ return completion_code_; }
	uint8 const & conn_status() const	{ return conn_status_; }
	array<uint8> const & data() const	{ return data_; }
	
protected:
	int length_;
	uint8 completion_code_;
	uint8 conn_status_;
	array<uint8> data_;
};


class ncp_frame
{
public:
	ncp_frame(int arg_is_orig, int arg_length);
	~ncp_frame();
	int parse(const uint8* const t_begin_of_data, const uint8* const t_end_of_data, int t_byteorder);
	
	// Member access functions
	int const is_orig() const { return is_orig_; };
	int const length() const { return length_; };
	uint16 const & frame_type() const	{ return frame_type_; }
	uint8 const & seq() const	{ return seq_; }
	uint8 const & conn_low() const	{ return conn_low_; }
	uint8 const & task() const	{ return task_; }
	uint8 const & conn_high() const	{ return conn_high_; }
	int const & body_length() const 	{ return body_length_; }
	int body_case_index() const	{ return body_case_index_; }
	ncp_request * const & request() const
		{
		if ( body_case_index() == 1 )
			return body_.request_;
		else
			throw ExceptionInvalidCase("./ncp.pac:27:request", body_case_index(), 1);
		}
	ncp_reply * const & reply() const
		{
		if ( body_case_index() == 0 )
			return body_.reply_;
		else
			throw ExceptionInvalidCase("./ncp.pac:28:reply", body_case_index(), 0);
		}
	
protected:
	int is_orig_;
	int length_;
	uint16 frame_type_;
	uint8 seq_;
	uint8 conn_low_;
	uint8 task_;
	uint8 conn_high_;
	int body_length_;
	int body_case_index_;
	union {
		ncp_request * request_;
		ncp_reply * reply_;
	} body_;
};


class ncp_over_tcpip_req_hdr
{
public:
	ncp_over_tcpip_req_hdr();
	~ncp_over_tcpip_req_hdr();
	int parse(const uint8* const t_begin_of_data, const uint8* const t_end_of_data, int t_byteorder);
	
	// Member access functions
	uint32 const & version() const	{ return version_; }
	uint32 const & reply_buf_size() const	{ return reply_buf_size_; }
	
protected:
	uint32 version_;
	uint32 reply_buf_size_;
};


class ncp_over_tcpip_frame
{
public:
	ncp_over_tcpip_frame(int arg_is_orig);
	~ncp_over_tcpip_frame();
	int parse(const uint8* const t_begin_of_data, const uint8* const t_end_of_data, int t_byteorder);
	
	// Member access functions
	int const is_orig() const { return is_orig_; };
	int const byteorder() const { return byteorder_; };
	uint32 const & signature() const	{ return signature_; }
	uint32 const & length() const	{ return length_; }
	int aux_case_index() const	{ return aux_case_index_; }
	ncp_over_tcpip_req_hdr * const & aux_req() const
		{
		if ( aux_case_index() == 1 )
			return aux_.aux_req_;
		else
			throw ExceptionInvalidCase("./ncp.pac:42:aux_req", aux_case_index(), 1);
		}
	ncp_frame * const & ncp() const	{ return ncp_; }
	
protected:
	int is_orig_;
	int byteorder_;
	uint32 signature_;
	uint32 length_;
	int aux_case_index_;
	union {
		ncp_over_tcpip_req_hdr * aux_req_;
	} aux_;
	ncp_frame * ncp_;
};

} /* namespace BinPAC */
#endif /* ncp_pac_h */
